package br.ime.usp.mac5855.otimizacao;

import java.util.ArrayList;

/**
 * @author Thadeu Russo
 * 
 * Classe que representa o dominio do problema a ser otimizado.<br/>
 * 
 * Um dominio eh composto de uma serie de limites inferior e superior.
 * */
public class Dominio {

	private ArrayList<int []> lista = new ArrayList<int []>(); 
	
	/**
	 * Adiciona nos valor do dominio, os limites inferior e superior.<br/>
	 * @param inferior O limite inferior.
	 * @param superior O limite superior.
	 * */
	public void adiciona(int inferior, int superior){
		lista.add(new int[]{inferior, superior});
	}
	
	/**
	 * Adiciona nos valor do dominio, os limites inferior e superior em uma posicao especifica.<br/>
	 * @param pos A posicao a ser inserido os valores de dominio.
	 * @param inferior O limite inferior.
	 * @param superior O limite superior.
	 * */
	public void adiciona(int pos, int inferior, int superior){
		lista.add(pos, new int[]{inferior, superior});
	}
	
	/**
	 * @return a quantidade de pares de limites deste dominio. 
	 * */
	public int getTamanho() {
		return lista.size();
	}

	/**
	 * @param pos A posicao do valor desejado
	 * @return o limite inferior da posicao indicada.
	 * */
	public int getLimiteInferior(int pos) {
		return lista.get(pos)[0];
	}

	/**
	 * @param pos A posicao do valor desejado
	 * @return o limite superior da posicao indicada.
	 * */
	public int getLimiteSuperior(int pos) {
		return lista.get(pos)[1];
	}

}
